(function (global, factory) {
    typeof exports === 'object' && typeof module !== 'undefined' ? factory(exports, require('@angular/core'), require('@angular/common'), require('@angular/forms')) :
    typeof define === 'function' && define.amd ? define('angular-bootstrap4-validate', ['exports', '@angular/core', '@angular/common', '@angular/forms'], factory) :
    (global = typeof globalThis !== 'undefined' ? globalThis : global || self, factory(global['angular-bootstrap4-validate'] = {}, global.ng.core, global.ng.common, global.ng.forms));
}(this, (function (exports, i0, common, i1) { 'use strict';

    function _interopNamespace(e) {
        if (e && e.__esModule) return e;
        var n = Object.create(null);
        if (e) {
            Object.keys(e).forEach(function (k) {
                if (k !== 'default') {
                    var d = Object.getOwnPropertyDescriptor(e, k);
                    Object.defineProperty(n, k, d.get ? d : {
                        enumerable: true,
                        get: function () {
                            return e[k];
                        }
                    });
                }
            });
        }
        n['default'] = e;
        return Object.freeze(n);
    }

    var i0__namespace = /*#__PURE__*/_interopNamespace(i0);
    var i1__namespace = /*#__PURE__*/_interopNamespace(i1);

    /*! *****************************************************************************
    Copyright (c) Microsoft Corporation.

    Permission to use, copy, modify, and/or distribute this software for any
    purpose with or without fee is hereby granted.

    THE SOFTWARE IS PROVIDED "AS IS" AND THE AUTHOR DISCLAIMS ALL WARRANTIES WITH
    REGARD TO THIS SOFTWARE INCLUDING ALL IMPLIED WARRANTIES OF MERCHANTABILITY
    AND FITNESS. IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY SPECIAL, DIRECT,
    INDIRECT, OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER RESULTING FROM
    LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF CONTRACT, NEGLIGENCE OR
    OTHER TORTIOUS ACTION, ARISING OUT OF OR IN CONNECTION WITH THE USE OR
    PERFORMANCE OF THIS SOFTWARE.
    ***************************************************************************** */
    /* global Reflect, Promise */
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b)
                if (Object.prototype.hasOwnProperty.call(b, p))
                    d[p] = b[p]; };
        return extendStatics(d, b);
    };
    function __extends(d, b) {
        if (typeof b !== "function" && b !== null)
            throw new TypeError("Class extends value " + String(b) + " is not a constructor or null");
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    }
    var __assign = function () {
        __assign = Object.assign || function __assign(t) {
            for (var s, i = 1, n = arguments.length; i < n; i++) {
                s = arguments[i];
                for (var p in s)
                    if (Object.prototype.hasOwnProperty.call(s, p))
                        t[p] = s[p];
            }
            return t;
        };
        return __assign.apply(this, arguments);
    };
    function __rest(s, e) {
        var t = {};
        for (var p in s)
            if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
                t[p] = s[p];
        if (s != null && typeof Object.getOwnPropertySymbols === "function")
            for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
                if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                    t[p[i]] = s[p[i]];
            }
        return t;
    }
    function __decorate(decorators, target, key, desc) {
        var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
        if (typeof Reflect === "object" && typeof Reflect.decorate === "function")
            r = Reflect.decorate(decorators, target, key, desc);
        else
            for (var i = decorators.length - 1; i >= 0; i--)
                if (d = decorators[i])
                    r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
        return c > 3 && r && Object.defineProperty(target, key, r), r;
    }
    function __param(paramIndex, decorator) {
        return function (target, key) { decorator(target, key, paramIndex); };
    }
    function __metadata(metadataKey, metadataValue) {
        if (typeof Reflect === "object" && typeof Reflect.metadata === "function")
            return Reflect.metadata(metadataKey, metadataValue);
    }
    function __awaiter(thisArg, _arguments, P, generator) {
        function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
        return new (P || (P = Promise))(function (resolve, reject) {
            function fulfilled(value) { try {
                step(generator.next(value));
            }
            catch (e) {
                reject(e);
            } }
            function rejected(value) { try {
                step(generator["throw"](value));
            }
            catch (e) {
                reject(e);
            } }
            function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
            step((generator = generator.apply(thisArg, _arguments || [])).next());
        });
    }
    function __generator(thisArg, body) {
        var _ = { label: 0, sent: function () { if (t[0] & 1)
                throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
        return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function () { return this; }), g;
        function verb(n) { return function (v) { return step([n, v]); }; }
        function step(op) {
            if (f)
                throw new TypeError("Generator is already executing.");
            while (_)
                try {
                    if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done)
                        return t;
                    if (y = 0, t)
                        op = [op[0] & 2, t.value];
                    switch (op[0]) {
                        case 0:
                        case 1:
                            t = op;
                            break;
                        case 4:
                            _.label++;
                            return { value: op[1], done: false };
                        case 5:
                            _.label++;
                            y = op[1];
                            op = [0];
                            continue;
                        case 7:
                            op = _.ops.pop();
                            _.trys.pop();
                            continue;
                        default:
                            if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) {
                                _ = 0;
                                continue;
                            }
                            if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) {
                                _.label = op[1];
                                break;
                            }
                            if (op[0] === 6 && _.label < t[1]) {
                                _.label = t[1];
                                t = op;
                                break;
                            }
                            if (t && _.label < t[2]) {
                                _.label = t[2];
                                _.ops.push(op);
                                break;
                            }
                            if (t[2])
                                _.ops.pop();
                            _.trys.pop();
                            continue;
                    }
                    op = body.call(thisArg, _);
                }
                catch (e) {
                    op = [6, e];
                    y = 0;
                }
                finally {
                    f = t = 0;
                }
            if (op[0] & 5)
                throw op[1];
            return { value: op[0] ? op[1] : void 0, done: true };
        }
    }
    var __createBinding = Object.create ? (function (o, m, k, k2) {
        if (k2 === undefined)
            k2 = k;
        Object.defineProperty(o, k2, { enumerable: true, get: function () { return m[k]; } });
    }) : (function (o, m, k, k2) {
        if (k2 === undefined)
            k2 = k;
        o[k2] = m[k];
    });
    function __exportStar(m, o) {
        for (var p in m)
            if (p !== "default" && !Object.prototype.hasOwnProperty.call(o, p))
                __createBinding(o, m, p);
    }
    function __values(o) {
        var s = typeof Symbol === "function" && Symbol.iterator, m = s && o[s], i = 0;
        if (m)
            return m.call(o);
        if (o && typeof o.length === "number")
            return {
                next: function () {
                    if (o && i >= o.length)
                        o = void 0;
                    return { value: o && o[i++], done: !o };
                }
            };
        throw new TypeError(s ? "Object is not iterable." : "Symbol.iterator is not defined.");
    }
    function __read(o, n) {
        var m = typeof Symbol === "function" && o[Symbol.iterator];
        if (!m)
            return o;
        var i = m.call(o), r, ar = [], e;
        try {
            while ((n === void 0 || n-- > 0) && !(r = i.next()).done)
                ar.push(r.value);
        }
        catch (error) {
            e = { error: error };
        }
        finally {
            try {
                if (r && !r.done && (m = i["return"]))
                    m.call(i);
            }
            finally {
                if (e)
                    throw e.error;
            }
        }
        return ar;
    }
    /** @deprecated */
    function __spread() {
        for (var ar = [], i = 0; i < arguments.length; i++)
            ar = ar.concat(__read(arguments[i]));
        return ar;
    }
    /** @deprecated */
    function __spreadArrays() {
        for (var s = 0, i = 0, il = arguments.length; i < il; i++)
            s += arguments[i].length;
        for (var r = Array(s), k = 0, i = 0; i < il; i++)
            for (var a = arguments[i], j = 0, jl = a.length; j < jl; j++, k++)
                r[k] = a[j];
        return r;
    }
    function __spreadArray(to, from, pack) {
        if (pack || arguments.length === 2)
            for (var i = 0, l = from.length, ar; i < l; i++) {
                if (ar || !(i in from)) {
                    if (!ar)
                        ar = Array.prototype.slice.call(from, 0, i);
                    ar[i] = from[i];
                }
            }
        return to.concat(ar || from);
    }
    function __await(v) {
        return this instanceof __await ? (this.v = v, this) : new __await(v);
    }
    function __asyncGenerator(thisArg, _arguments, generator) {
        if (!Symbol.asyncIterator)
            throw new TypeError("Symbol.asyncIterator is not defined.");
        var g = generator.apply(thisArg, _arguments || []), i, q = [];
        return i = {}, verb("next"), verb("throw"), verb("return"), i[Symbol.asyncIterator] = function () { return this; }, i;
        function verb(n) { if (g[n])
            i[n] = function (v) { return new Promise(function (a, b) { q.push([n, v, a, b]) > 1 || resume(n, v); }); }; }
        function resume(n, v) { try {
            step(g[n](v));
        }
        catch (e) {
            settle(q[0][3], e);
        } }
        function step(r) { r.value instanceof __await ? Promise.resolve(r.value.v).then(fulfill, reject) : settle(q[0][2], r); }
        function fulfill(value) { resume("next", value); }
        function reject(value) { resume("throw", value); }
        function settle(f, v) { if (f(v), q.shift(), q.length)
            resume(q[0][0], q[0][1]); }
    }
    function __asyncDelegator(o) {
        var i, p;
        return i = {}, verb("next"), verb("throw", function (e) { throw e; }), verb("return"), i[Symbol.iterator] = function () { return this; }, i;
        function verb(n, f) { i[n] = o[n] ? function (v) { return (p = !p) ? { value: __await(o[n](v)), done: n === "return" } : f ? f(v) : v; } : f; }
    }
    function __asyncValues(o) {
        if (!Symbol.asyncIterator)
            throw new TypeError("Symbol.asyncIterator is not defined.");
        var m = o[Symbol.asyncIterator], i;
        return m ? m.call(o) : (o = typeof __values === "function" ? __values(o) : o[Symbol.iterator](), i = {}, verb("next"), verb("throw"), verb("return"), i[Symbol.asyncIterator] = function () { return this; }, i);
        function verb(n) { i[n] = o[n] && function (v) { return new Promise(function (resolve, reject) { v = o[n](v), settle(resolve, reject, v.done, v.value); }); }; }
        function settle(resolve, reject, d, v) { Promise.resolve(v).then(function (v) { resolve({ value: v, done: d }); }, reject); }
    }
    function __makeTemplateObject(cooked, raw) {
        if (Object.defineProperty) {
            Object.defineProperty(cooked, "raw", { value: raw });
        }
        else {
            cooked.raw = raw;
        }
        return cooked;
    }
    ;
    var __setModuleDefault = Object.create ? (function (o, v) {
        Object.defineProperty(o, "default", { enumerable: true, value: v });
    }) : function (o, v) {
        o["default"] = v;
    };
    function __importStar(mod) {
        if (mod && mod.__esModule)
            return mod;
        var result = {};
        if (mod != null)
            for (var k in mod)
                if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k))
                    __createBinding(result, mod, k);
        __setModuleDefault(result, mod);
        return result;
    }
    function __importDefault(mod) {
        return (mod && mod.__esModule) ? mod : { default: mod };
    }
    function __classPrivateFieldGet(receiver, state, kind, f) {
        if (kind === "a" && !f)
            throw new TypeError("Private accessor was defined without a getter");
        if (typeof state === "function" ? receiver !== state || !f : !state.has(receiver))
            throw new TypeError("Cannot read private member from an object whose class did not declare it");
        return kind === "m" ? f : kind === "a" ? f.call(receiver) : f ? f.value : state.get(receiver);
    }
    function __classPrivateFieldSet(receiver, state, value, kind, f) {
        if (kind === "m")
            throw new TypeError("Private method is not writable");
        if (kind === "a" && !f)
            throw new TypeError("Private accessor was defined without a setter");
        if (typeof state === "function" ? receiver !== state || !f : !state.has(receiver))
            throw new TypeError("Cannot write private member to an object whose class did not declare it");
        return (kind === "a" ? f.call(receiver, value) : f ? f.value = value : state.set(receiver, value)), value;
    }

    var VALIDATE_ELEMENT = new i0.InjectionToken('Validate element');
    // eslint-disable-next-line @angular-eslint/use-injectable-provided-in
    var AbstractValidateElementDirective = /** @class */ (function () {
        function AbstractValidateElementDirective() {
            this.errorMessages = [];
            this.isGroup = false;
        }
        // eslint-disable-next-line @angular-eslint/contextual-lifecycle
        AbstractValidateElementDirective.prototype.ngOnInit = function () {
            if ('validity' in this.elementRef.nativeElement) {
                this.ngControl.control.__elementValidity
                    = this.elementRef.nativeElement.validity;
            }
            if (!this.feedbackElementContainer && this.elementRef.nativeElement.classList.contains('form-group')) {
                this.feedbackElementContainer = this.elementRef.nativeElement;
            }
        };
        // eslint-disable-next-line @angular-eslint/contextual-lifecycle
        AbstractValidateElementDirective.prototype.ngAfterViewChecked = function () {
            var _this = this;
            var _a, _b;
            if (!this.ngFormValidate) {
                return;
            }
            if (!this.isGroup && this.ngControl.dirty && this.ngControl.touched) {
                (_a = (this.feedbackElementContainer || this.elementRef.nativeElement.parentElement)) === null || _a === void 0 ? void 0 : _a.classList.add('was-validated');
            }
            if ( // prevent creating feedbackElement when it's not yet needed
            !this.feedbackElement
                && this.ngControl.valid) {
                return;
            }
            if (!this.feedbackElement) {
                var feedbackElement = this.createFeedBackElement();
                if (!feedbackElement) {
                    return;
                }
                this.feedbackElement = feedbackElement;
                if (this.config.inputGroupFix) {
                    this.inputGroupFix();
                }
                this.differ = this.keyValueDiffers.find({}).create();
            }
            if (!((_b = this.differ) === null || _b === void 0 ? void 0 : _b.diff(this.ngControl.errors || {}))) {
                return;
            }
            this.errorMessages.length = 0;
            if (this.ngControl.errors !== null) {
                Object.entries(this.ngControl.errors || {})
                    .forEach(function (_e) {
                    var _f = __read(_e, 2), error = _f[0], errorValue = _f[1];
                    var msg = _this.config.errorMessages[error];
                    if (typeof _this.errorMessage !== 'undefined'
                        && typeof _this.errorMessage[error] !== 'undefined') {
                        msg = _this.errorMessage[error];
                    }
                    if (msg) {
                        _this.errorMessages.push(msg.replace('%s', _this.getErrorValue(error, errorValue)));
                    }
                });
            }
            this.feedbackElement.textContent = this.errorMessages.join(',');
        };
        AbstractValidateElementDirective.prototype.ngOnDestroy = function () {
            if (this.feedbackElement) {
                this.feedbackElement.remove();
            }
        };
        AbstractValidateElementDirective.prototype.createFeedBackElement = function () {
            var parent = this.feedbackElementContainer || this.elementRef.nativeElement.parentNode;
            if (parent) {
                var feedbackElement = this.document.createElement('div');
                feedbackElement.classList.add("invalid-" + this.ngFormValidate.validateMode);
                parent.appendChild(feedbackElement);
                return feedbackElement;
            }
            return null;
        };
        AbstractValidateElementDirective.prototype.inputGroupFix = function () {
            var _a, _b, _c, _d;
            var parent = this.elementRef.nativeElement.parentElement;
            if (parent) {
                if (parent.classList.contains('input-group')) {
                    (_b = (_a = this.feedbackElement) === null || _a === void 0 ? void 0 : _a.previousElementSibling) === null || _b === void 0 ? void 0 : _b.classList.add('rounded-right');
                }
                else {
                    (_d = (_c = this.feedbackElement) === null || _c === void 0 ? void 0 : _c.previousElementSibling) === null || _d === void 0 ? void 0 : _d.classList.remove('rounded-right');
                }
            }
        };
        AbstractValidateElementDirective.prototype.getErrorValue = function (error, errorValue) {
            if (errorValue === null) {
                return '';
            }
            if (typeof errorValue === 'object') {
                if (error === 'minlength' || error === 'maxlength') {
                    return errorValue.requiredLength.toString();
                }
                else if (error === 'pattern') {
                    return errorValue.requiredPattern;
                }
                if (error in errorValue) {
                    errorValue = errorValue[error];
                }
            }
            switch (typeof errorValue) {
                case 'number':
                    return errorValue.toString();
                case 'string':
                    return errorValue;
                case 'undefined':
                case 'boolean':
                case 'function':
                case 'symbol':
                default:
                    return '';
            }
        };
        return AbstractValidateElementDirective;
    }());
    AbstractValidateElementDirective.ɵfac = i0__namespace.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "12.0.5", ngImport: i0__namespace, type: AbstractValidateElementDirective, deps: [], target: i0__namespace.ɵɵFactoryTarget.Injectable });
    AbstractValidateElementDirective.ɵprov = i0__namespace.ɵɵngDeclareInjectable({ minVersion: "12.0.0", version: "12.0.5", ngImport: i0__namespace, type: AbstractValidateElementDirective });
    i0__namespace.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "12.0.5", ngImport: i0__namespace, type: AbstractValidateElementDirective, decorators: [{
                type: i0.Injectable
            }] });

    /*
     * Angular validation plugin for  Bootstrap 4
     *  Copyright (c) 2019-2021 Rodziu <mateusz.rohde@gmail.com>
     *  License: MIT
     */
    var ValidateConfigService = /** @class */ (function () {
        function ValidateConfigService() {
            this.mode = 'feedback';
            this.inputGroupFix = true;
            this.errorMessages = {
                required: 'This field is required',
                min: 'Minimum value is %s',
                max: 'Maximum value is %s',
                pattern: 'Please ensure the entered information adheres to this pattern: %s',
                number: 'Please enter a valid number',
                email: 'Please enter a valid e-mail',
                minlength: 'Minimum length of this field is %s characters',
                maxlength: 'Maximum length of this field is %s characters',
                equal: 'These fields needs to be equal',
                url: 'Please enter a valid URL (http(s)://example.com)',
                urlMultiple: 'Please enter valid URLs (http(s)://example.com), each one in new line!',
                host: 'Please enter valid host (example.com)',
                hostMultiple: 'Please enter valid hosts (example.com), each one in new line!',
                requiredGroupOr: 'At least one of these fields is required',
                requiredGroupAnd: 'All of these fields are required',
            };
        }
        return ValidateConfigService;
    }());
    ValidateConfigService.ɵfac = i0__namespace.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "12.0.5", ngImport: i0__namespace, type: ValidateConfigService, deps: [], target: i0__namespace.ɵɵFactoryTarget.Injectable });
    ValidateConfigService.ɵprov = i0__namespace.ɵɵngDeclareInjectable({ minVersion: "12.0.0", version: "12.0.5", ngImport: i0__namespace, type: ValidateConfigService, providedIn: 'root' });
    i0__namespace.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "12.0.5", ngImport: i0__namespace, type: ValidateConfigService, decorators: [{
                type: i0.Injectable,
                args: [{
                        providedIn: 'root'
                    }]
            }] });

    var NgFormValidateDirective = /** @class */ (function (_super) {
        __extends(NgFormValidateDirective, _super);
        function NgFormValidateDirective(ngForm, formGroup, formGroupName, parent, config, elementRef, keyValueDiffers, document) {
            var _this = this;
            var _a;
            _this = _super.call(this) || this;
            _this.ngForm = ngForm;
            _this.formGroup = formGroup;
            _this.formGroupName = formGroupName;
            _this.parent = parent;
            _this.config = config;
            _this.elementRef = elementRef;
            _this.keyValueDiffers = keyValueDiffers;
            _this.document = document;
            _this.ngFormValidate = _this;
            _this.isGroup = true;
            _this.validateMode = config.mode;
            _this.wasValidated = elementRef.nativeElement.classList.contains('was-validated');
            _this.feedbackElementContainer = _this.elementRef.nativeElement;
            _this.ngControl = _this.ngForm || _this.formGroup || _this.formGroupName;
            (_a = (_this.ngForm || _this.formGroup)) === null || _a === void 0 ? void 0 : _a.ngSubmit.subscribe(function () {
                _this.showValidation();
            });
            return _this;
        }
        NgFormValidateDirective.prototype.showValidation = function () {
            this.elementRef.nativeElement.classList.add('was-validated');
            this.wasValidated = true;
        };
        NgFormValidateDirective.prototype.resetValidation = function () {
            if (this.parent) {
                this.parent.resetValidation();
                return;
            }
            this.children.forEach(function (child) {
                var _a;
                var form = child.formGroupName
                    ? (_a = child.formGroupName.formDirective) === null || _a === void 0 ? void 0 : _a.getFormGroup(child.formGroupName)
                    : (child.ngForm || child.formGroup).form;
                form === null || form === void 0 ? void 0 : form.markAsPristine();
            });
            this.elementRef.nativeElement.querySelectorAll('.was-validated')
                .forEach(function (node) {
                node.classList.remove('was-validated');
            });
            this.elementRef.nativeElement.classList.remove('was-validated');
            this.wasValidated = false;
        };
        return NgFormValidateDirective;
    }(AbstractValidateElementDirective));
    NgFormValidateDirective.ɵfac = i0__namespace.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "12.0.5", ngImport: i0__namespace, type: NgFormValidateDirective, deps: [{ token: i1__namespace.NgForm, optional: true, self: true }, { token: i1__namespace.FormGroupDirective, optional: true, self: true }, { token: i1__namespace.FormGroupName, optional: true, self: true }, { token: NgFormValidateDirective, optional: true, skipSelf: true }, { token: ValidateConfigService }, { token: i0__namespace.ElementRef }, { token: i0__namespace.KeyValueDiffers }, { token: common.DOCUMENT }], target: i0__namespace.ɵɵFactoryTarget.Directive });
    NgFormValidateDirective.ɵdir = i0__namespace.ɵɵngDeclareDirective({ minVersion: "12.0.0", version: "12.0.5", type: NgFormValidateDirective, selector: "form:not([ngNoForm]),ng-form,[ngForm],[formGroup],[formGroupName]", inputs: { validateMode: "validateMode", errorMessage: "errorMessage" }, providers: [
            {
                provide: VALIDATE_ELEMENT,
                useExisting: NgFormValidateDirective
            }
        ], queries: [{ propertyName: "children", predicate: NgFormValidateDirective, descendants: true }], exportAs: ["ngFormValidate"], usesInheritance: true, ngImport: i0__namespace });
    i0__namespace.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "12.0.5", ngImport: i0__namespace, type: NgFormValidateDirective, decorators: [{
                type: i0.Directive,
                args: [{
                        selector: 'form:not([ngNoForm]),ng-form,[ngForm],[formGroup],[formGroupName]',
                        exportAs: 'ngFormValidate',
                        providers: [
                            {
                                provide: VALIDATE_ELEMENT,
                                useExisting: NgFormValidateDirective
                            }
                        ]
                    }]
            }], ctorParameters: function () {
            return [{ type: i1__namespace.NgForm, decorators: [{
                            type: i0.Self
                        }, {
                            type: i0.Optional
                        }] }, { type: i1__namespace.FormGroupDirective, decorators: [{
                            type: i0.Self
                        }, {
                            type: i0.Optional
                        }] }, { type: i1__namespace.FormGroupName, decorators: [{
                            type: i0.Self
                        }, {
                            type: i0.Optional
                        }] }, { type: NgFormValidateDirective, decorators: [{
                            type: i0.SkipSelf
                        }, {
                            type: i0.Optional
                        }] }, { type: ValidateConfigService }, { type: i0__namespace.ElementRef }, { type: i0__namespace.KeyValueDiffers }, { type: Document, decorators: [{
                            type: i0.Inject,
                            args: [common.DOCUMENT]
                        }] }];
        }, propDecorators: { validateMode: [{
                    type: i0.Input
                }], errorMessage: [{
                    type: i0.Input
                }], children: [{
                    type: i0.ContentChildren,
                    args: [NgFormValidateDirective, { descendants: true }]
                }] } });

    var NgModelValidateDirective = /** @class */ (function (_super) {
        __extends(NgModelValidateDirective, _super);
        // eslint-disable-next-line @typescript-eslint/no-useless-constructor
        function NgModelValidateDirective(elementRef, config, keyValueDiffers, ngControl, ngFormValidate, document) {
            var _this = _super.call(this) || this;
            _this.elementRef = elementRef;
            _this.config = config;
            _this.keyValueDiffers = keyValueDiffers;
            _this.ngControl = ngControl;
            _this.ngFormValidate = ngFormValidate;
            _this.document = document;
            return _this;
        }
        return NgModelValidateDirective;
    }(AbstractValidateElementDirective));
    NgModelValidateDirective.ɵfac = i0__namespace.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "12.0.5", ngImport: i0__namespace, type: NgModelValidateDirective, deps: [{ token: i0__namespace.ElementRef }, { token: ValidateConfigService }, { token: i0__namespace.KeyValueDiffers }, { token: i1__namespace.NgModel, self: true }, { token: NgFormValidateDirective, optional: true }, { token: common.DOCUMENT }], target: i0__namespace.ɵɵFactoryTarget.Directive });
    NgModelValidateDirective.ɵdir = i0__namespace.ɵɵngDeclareDirective({ minVersion: "12.0.0", version: "12.0.5", type: NgModelValidateDirective, selector: "[ngModel]", inputs: { errorMessage: "errorMessage" }, providers: [
            {
                provide: VALIDATE_ELEMENT,
                useExisting: NgModelValidateDirective
            }
        ], usesInheritance: true, ngImport: i0__namespace });
    i0__namespace.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "12.0.5", ngImport: i0__namespace, type: NgModelValidateDirective, decorators: [{
                type: i0.Directive,
                args: [{
                        selector: '[ngModel]',
                        providers: [
                            {
                                provide: VALIDATE_ELEMENT,
                                useExisting: NgModelValidateDirective
                            }
                        ]
                    }]
            }], ctorParameters: function () {
            return [{ type: i0__namespace.ElementRef }, { type: ValidateConfigService }, { type: i0__namespace.KeyValueDiffers }, { type: i1__namespace.NgModel, decorators: [{
                            type: i0.Self
                        }] }, { type: NgFormValidateDirective, decorators: [{
                            type: i0.Optional
                        }] }, { type: Document, decorators: [{
                            type: i0.Inject,
                            args: [common.DOCUMENT]
                        }] }];
        }, propDecorators: { errorMessage: [{
                    type: i0.Input
                }] } });

    var FormControlNameValidateDirective = /** @class */ (function (_super) {
        __extends(FormControlNameValidateDirective, _super);
        // eslint-disable-next-line @typescript-eslint/no-useless-constructor
        function FormControlNameValidateDirective(elementRef, config, keyValueDiffers, ngControl, ngFormValidate, document) {
            var _this = _super.call(this) || this;
            _this.elementRef = elementRef;
            _this.config = config;
            _this.keyValueDiffers = keyValueDiffers;
            _this.ngControl = ngControl;
            _this.ngFormValidate = ngFormValidate;
            _this.document = document;
            return _this;
        }
        return FormControlNameValidateDirective;
    }(AbstractValidateElementDirective));
    FormControlNameValidateDirective.ɵfac = i0__namespace.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "12.0.5", ngImport: i0__namespace, type: FormControlNameValidateDirective, deps: [{ token: i0__namespace.ElementRef }, { token: ValidateConfigService }, { token: i0__namespace.KeyValueDiffers }, { token: i1__namespace.FormControlName, self: true }, { token: NgFormValidateDirective, optional: true }, { token: common.DOCUMENT }], target: i0__namespace.ɵɵFactoryTarget.Directive });
    FormControlNameValidateDirective.ɵdir = i0__namespace.ɵɵngDeclareDirective({ minVersion: "12.0.0", version: "12.0.5", type: FormControlNameValidateDirective, selector: "[formControlName]", inputs: { errorMessage: "errorMessage" }, providers: [
            {
                provide: VALIDATE_ELEMENT,
                useExisting: FormControlNameValidateDirective
            }
        ], usesInheritance: true, ngImport: i0__namespace });
    i0__namespace.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "12.0.5", ngImport: i0__namespace, type: FormControlNameValidateDirective, decorators: [{
                type: i0.Directive,
                args: [{
                        selector: '[formControlName]',
                        providers: [
                            {
                                provide: VALIDATE_ELEMENT,
                                useExisting: FormControlNameValidateDirective
                            }
                        ]
                    }]
            }], ctorParameters: function () {
            return [{ type: i0__namespace.ElementRef }, { type: ValidateConfigService }, { type: i0__namespace.KeyValueDiffers }, { type: i1__namespace.FormControlName, decorators: [{
                            type: i0.Self
                        }] }, { type: NgFormValidateDirective, decorators: [{
                            type: i0.Optional
                        }] }, { type: Document, decorators: [{
                            type: i0.Inject,
                            args: [common.DOCUMENT]
                        }] }];
        }, propDecorators: { errorMessage: [{
                    type: i0.Input
                }] } });

    var FormControlValidateDirective = /** @class */ (function (_super) {
        __extends(FormControlValidateDirective, _super);
        // eslint-disable-next-line @typescript-eslint/no-useless-constructor
        function FormControlValidateDirective(elementRef, config, keyValueDiffers, ngControl, ngFormValidate, document) {
            var _this = _super.call(this) || this;
            _this.elementRef = elementRef;
            _this.config = config;
            _this.keyValueDiffers = keyValueDiffers;
            _this.ngControl = ngControl;
            _this.ngFormValidate = ngFormValidate;
            _this.document = document;
            return _this;
        }
        return FormControlValidateDirective;
    }(AbstractValidateElementDirective));
    FormControlValidateDirective.ɵfac = i0__namespace.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "12.0.5", ngImport: i0__namespace, type: FormControlValidateDirective, deps: [{ token: i0__namespace.ElementRef }, { token: ValidateConfigService }, { token: i0__namespace.KeyValueDiffers }, { token: i1__namespace.FormControlDirective, self: true }, { token: NgFormValidateDirective, optional: true }, { token: common.DOCUMENT }], target: i0__namespace.ɵɵFactoryTarget.Directive });
    FormControlValidateDirective.ɵdir = i0__namespace.ɵɵngDeclareDirective({ minVersion: "12.0.0", version: "12.0.5", type: FormControlValidateDirective, selector: "[formControl]", inputs: { errorMessage: "errorMessage" }, providers: [
            {
                provide: VALIDATE_ELEMENT,
                useExisting: FormControlValidateDirective
            }
        ], usesInheritance: true, ngImport: i0__namespace });
    i0__namespace.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "12.0.5", ngImport: i0__namespace, type: FormControlValidateDirective, decorators: [{
                type: i0.Directive,
                args: [{
                        selector: '[formControl]',
                        providers: [
                            {
                                provide: VALIDATE_ELEMENT,
                                useExisting: FormControlValidateDirective
                            }
                        ]
                    }]
            }], ctorParameters: function () {
            return [{ type: i0__namespace.ElementRef }, { type: ValidateConfigService }, { type: i0__namespace.KeyValueDiffers }, { type: i1__namespace.FormControlDirective, decorators: [{
                            type: i0.Self
                        }] }, { type: NgFormValidateDirective, decorators: [{
                            type: i0.Optional
                        }] }, { type: Document, decorators: [{
                            type: i0.Inject,
                            args: [common.DOCUMENT]
                        }] }];
        }, propDecorators: { errorMessage: [{
                    type: i0.Input
                }] } });

    var Validators = /** @class */ (function (_super) {
        __extends(Validators, _super);
        function Validators() {
            return _super !== null && _super.apply(this, arguments) || this;
        }
        Validators.number = function (control) {
            if (control.__elementValidity && control.__elementValidity.badInput) {
                return {
                    number: true
                };
            }
            return null;
        };
        Validators.url = function (mode) {
            if (mode === void 0) { mode = 'single'; }
            return function (control) {
                return validateSingleOrMultiple(mode, control, function (value) { return /^https?:\/\/.+/.test(value); }, 'url');
            };
        };
        Validators.host = function (mode) {
            if (mode === void 0) { mode = 'single'; }
            return function (control) {
                return validateSingleOrMultiple(mode, control, 
                // eslint-disable-next-line max-len
                function (value) { return /^([a-z\u00A1-\uFFFF0-9]|[a-z\u00A1-\uFFFF0-9][a-z\u00A1-\uFFFF0-9-]{0,61}[a-z\u00A1-\uFFFF0-9])(\.([a-z\u00A1-\uFFFF0-9]|[a-z\u00A1-\uFFFF0-9][a-z\u00A1-\uFFFF0-9-]{0,61}[a-z\u00A1-\uFFFF0-9]))*$/i.test(value); }, 'host');
            };
        };
        Validators.equal = function () {
            var controlNames = [];
            for (var _i = 0; _i < arguments.length; _i++) {
                controlNames[_i] = arguments[_i];
            }
            return function (controlGroup) {
                var isValid = getControls(controlGroup, controlNames)
                    .every(function (control, idx, controls) {
                    if (idx === 0) {
                        return true;
                    }
                    var previous = controls[idx - 1];
                    return control !== null && previous !== null && control.value === previous.value;
                });
                return isValid ? null : {
                    equal: true
                };
            };
        };
        Validators.requiredGroup = function (mode, value) {
            if (mode === void 0) { mode = 'or'; }
            var controlNames = [];
            for (var _i = 2; _i < arguments.length; _i++) {
                controlNames[_i - 2] = arguments[_i];
            }
            return function (controlGroup) {
                var _a;
                var controls = getControls(controlGroup, controlNames), validateControl = function (control) {
                    return typeof value === 'undefined'
                        ? control.value !== null && control.value.length
                        : control.value === value;
                };
                var isValid = mode === 'or'
                    ? controls.some(validateControl)
                    : controls.every(validateControl);
                return isValid ? null : (_a = {},
                    _a["requiredGroup" + (mode === 'or' ? 'Or' : 'And')] = typeof value === 'undefined' ? true : value,
                    _a);
            };
        };
        return Validators;
    }(i1.Validators));
    function validateSingleOrMultiple(mode, control, validator, validatorName) {
        var _a;
        var isValid = true;
        if (typeof control.value === 'string' && control.value.length) {
            if (mode === 'multiple') {
                var rows = control.value.split(/\r\n|\r|\n/);
                isValid = !rows.some(function (line) {
                    line = line.trim();
                    return line.length && !validator(line);
                });
            }
            else {
                isValid = validator(control.value);
            }
        }
        return isValid ? null : (_a = {},
            _a[mode === 'single' ? validatorName : validatorName + "Multiple"] = true,
            _a);
    }
    function getControls(controlGroup, controlNames) {
        return controlNames.length || !('controls' in controlGroup)
            ? controlNames
                .map(function (controlName) { return controlGroup.get(controlName); })
                .filter(function (x) { return x !== null; })
            : Object.values(controlGroup.controls);
    }

    /*
     * Angular validation plugin for  Bootstrap 4
     *  Copyright (c) 2019-2021 Rodziu <mateusz.rohde@gmail.com>
     *  License: MIT
     */
    var NumberValidatorDirective = /** @class */ (function () {
        function NumberValidatorDirective() {
        }
        NumberValidatorDirective.prototype.validate = function (control) {
            return Validators.number(control);
        };
        return NumberValidatorDirective;
    }());
    NumberValidatorDirective.ɵfac = i0__namespace.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "12.0.5", ngImport: i0__namespace, type: NumberValidatorDirective, deps: [], target: i0__namespace.ɵɵFactoryTarget.Directive });
    NumberValidatorDirective.ɵdir = i0__namespace.ɵɵngDeclareDirective({ minVersion: "12.0.0", version: "12.0.5", type: NumberValidatorDirective, selector: "[number]", providers: [
            {
                provide: i1.NG_VALIDATORS,
                useExisting: NumberValidatorDirective,
                multi: true
            }
        ], ngImport: i0__namespace });
    i0__namespace.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "12.0.5", ngImport: i0__namespace, type: NumberValidatorDirective, decorators: [{
                type: i0.Directive,
                args: [{
                        selector: '[number]',
                        providers: [
                            {
                                provide: i1.NG_VALIDATORS,
                                useExisting: NumberValidatorDirective,
                                multi: true
                            }
                        ]
                    }]
            }] });

    /*
     * Angular validation plugin for  Bootstrap 4
     *  Copyright (c) 2019-2021 Rodziu <mateusz.rohde@gmail.com>
     *  License: MIT
     */
    var UrlValidatorDirective = /** @class */ (function () {
        function UrlValidatorDirective() {
        }
        UrlValidatorDirective.prototype.validate = function (control) {
            return Validators.url(this.mode || 'single')(control);
        };
        return UrlValidatorDirective;
    }());
    UrlValidatorDirective.ɵfac = i0__namespace.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "12.0.5", ngImport: i0__namespace, type: UrlValidatorDirective, deps: [], target: i0__namespace.ɵɵFactoryTarget.Directive });
    UrlValidatorDirective.ɵdir = i0__namespace.ɵɵngDeclareDirective({ minVersion: "12.0.0", version: "12.0.5", type: UrlValidatorDirective, selector: "[url]", inputs: { mode: ["url", "mode"] }, providers: [
            {
                provide: i1.NG_VALIDATORS,
                useExisting: UrlValidatorDirective,
                multi: true
            }
        ], ngImport: i0__namespace });
    i0__namespace.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "12.0.5", ngImport: i0__namespace, type: UrlValidatorDirective, decorators: [{
                type: i0.Directive,
                args: [{
                        selector: '[url]',
                        providers: [
                            {
                                provide: i1.NG_VALIDATORS,
                                useExisting: UrlValidatorDirective,
                                multi: true
                            }
                        ]
                    }]
            }], propDecorators: { mode: [{
                    type: i0.Input,
                    args: ['url']
                }] } });

    /*
     * Angular validation plugin for  Bootstrap 4
     *  Copyright (c) 2019-2021 Rodziu <mateusz.rohde@gmail.com>
     *  License: MIT
     */
    var HostValidatorDirective = /** @class */ (function () {
        function HostValidatorDirective() {
        }
        HostValidatorDirective.prototype.validate = function (control) {
            return Validators.host(this.mode || 'single')(control);
        };
        return HostValidatorDirective;
    }());
    HostValidatorDirective.ɵfac = i0__namespace.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "12.0.5", ngImport: i0__namespace, type: HostValidatorDirective, deps: [], target: i0__namespace.ɵɵFactoryTarget.Directive });
    HostValidatorDirective.ɵdir = i0__namespace.ɵɵngDeclareDirective({ minVersion: "12.0.0", version: "12.0.5", type: HostValidatorDirective, selector: "[host]", inputs: { mode: ["host", "mode"] }, providers: [
            {
                provide: i1.NG_VALIDATORS,
                useExisting: HostValidatorDirective,
                multi: true
            }
        ], ngImport: i0__namespace });
    i0__namespace.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "12.0.5", ngImport: i0__namespace, type: HostValidatorDirective, decorators: [{
                type: i0.Directive,
                args: [{
                        selector: '[host]',
                        providers: [
                            {
                                provide: i1.NG_VALIDATORS,
                                useExisting: HostValidatorDirective,
                                multi: true
                            }
                        ]
                    }]
            }], propDecorators: { mode: [{
                    type: i0.Input,
                    args: ['host']
                }] } });

    var EqualValidatorDirective = /** @class */ (function () {
        function EqualValidatorDirective() {
            this.controlNames = [];
        }
        EqualValidatorDirective.prototype.validate = function (control) {
            return Validators.equal.apply(Validators, __spreadArray([], __read((this.controlNames || []))))(control);
        };
        return EqualValidatorDirective;
    }());
    EqualValidatorDirective.ɵfac = i0__namespace.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "12.0.5", ngImport: i0__namespace, type: EqualValidatorDirective, deps: [], target: i0__namespace.ɵɵFactoryTarget.Directive });
    EqualValidatorDirective.ɵdir = i0__namespace.ɵɵngDeclareDirective({ minVersion: "12.0.0", version: "12.0.5", type: EqualValidatorDirective, selector: "[equal]", inputs: { controlNames: ["equal", "controlNames"] }, providers: [
            {
                provide: i1.NG_VALIDATORS,
                useExisting: EqualValidatorDirective,
                multi: true
            }
        ], ngImport: i0__namespace });
    i0__namespace.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "12.0.5", ngImport: i0__namespace, type: EqualValidatorDirective, decorators: [{
                type: i0.Directive,
                args: [{
                        selector: '[equal]',
                        providers: [
                            {
                                provide: i1.NG_VALIDATORS,
                                useExisting: EqualValidatorDirective,
                                multi: true
                            }
                        ]
                    }]
            }], propDecorators: { controlNames: [{
                    type: i0.Input,
                    args: ['equal']
                }] } });

    var RequiredGroupValidatorDirective = /** @class */ (function () {
        function RequiredGroupValidatorDirective() {
        }
        RequiredGroupValidatorDirective.prototype.validate = function (controlGroup) {
            var options = typeof this.requiredGroup === 'object' ? this.requiredGroup : {};
            return Validators.requiredGroup.apply(Validators, __spreadArray([options === null || options === void 0 ? void 0 : options.mode, options === null || options === void 0 ? void 0 : options.value], __read(((options === null || options === void 0 ? void 0 : options.controlNames) || []))))(controlGroup);
        };
        return RequiredGroupValidatorDirective;
    }());
    RequiredGroupValidatorDirective.ɵfac = i0__namespace.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "12.0.5", ngImport: i0__namespace, type: RequiredGroupValidatorDirective, deps: [], target: i0__namespace.ɵɵFactoryTarget.Directive });
    RequiredGroupValidatorDirective.ɵdir = i0__namespace.ɵɵngDeclareDirective({ minVersion: "12.0.0", version: "12.0.5", type: RequiredGroupValidatorDirective, selector: "[requiredGroup]", inputs: { requiredGroup: "requiredGroup" }, providers: [
            {
                provide: i1.NG_VALIDATORS,
                useExisting: RequiredGroupValidatorDirective,
                multi: true
            }
        ], ngImport: i0__namespace });
    i0__namespace.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "12.0.5", ngImport: i0__namespace, type: RequiredGroupValidatorDirective, decorators: [{
                type: i0.Directive,
                args: [{
                        selector: '[requiredGroup]',
                        providers: [
                            {
                                provide: i1.NG_VALIDATORS,
                                useExisting: RequiredGroupValidatorDirective,
                                multi: true
                            }
                        ]
                    }]
            }], propDecorators: { requiredGroup: [{
                    type: i0.Input
                }] } });

    /*
     * Angular validation plugin for  Bootstrap 4
     *  Copyright (c) 2019-2021 Rodziu <mateusz.rohde@gmail.com>
     *  License: MIT
     */
    var ValidatorsModule = /** @class */ (function () {
        function ValidatorsModule() {
        }
        return ValidatorsModule;
    }());
    ValidatorsModule.ɵfac = i0__namespace.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "12.0.5", ngImport: i0__namespace, type: ValidatorsModule, deps: [], target: i0__namespace.ɵɵFactoryTarget.NgModule });
    ValidatorsModule.ɵmod = i0__namespace.ɵɵngDeclareNgModule({ minVersion: "12.0.0", version: "12.0.5", ngImport: i0__namespace, type: ValidatorsModule, declarations: [EqualValidatorDirective,
            HostValidatorDirective,
            NumberValidatorDirective,
            RequiredGroupValidatorDirective,
            UrlValidatorDirective], exports: [EqualValidatorDirective,
            HostValidatorDirective,
            NumberValidatorDirective,
            RequiredGroupValidatorDirective,
            UrlValidatorDirective] });
    ValidatorsModule.ɵinj = i0__namespace.ɵɵngDeclareInjector({ minVersion: "12.0.0", version: "12.0.5", ngImport: i0__namespace, type: ValidatorsModule });
    i0__namespace.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "12.0.5", ngImport: i0__namespace, type: ValidatorsModule, decorators: [{
                type: i0.NgModule,
                args: [{
                        declarations: [
                            EqualValidatorDirective,
                            HostValidatorDirective,
                            NumberValidatorDirective,
                            RequiredGroupValidatorDirective,
                            UrlValidatorDirective,
                        ],
                        exports: [
                            EqualValidatorDirective,
                            HostValidatorDirective,
                            NumberValidatorDirective,
                            RequiredGroupValidatorDirective,
                            UrlValidatorDirective,
                        ]
                    }]
            }] });

    /*
     * Angular validation plugin for  Bootstrap 4
     *  Copyright (c) 2019-2021 Rodziu <mateusz.rohde@gmail.com>
     *  License: MIT
     */
    var ValidateModule = /** @class */ (function () {
        function ValidateModule() {
        }
        return ValidateModule;
    }());
    ValidateModule.ɵfac = i0__namespace.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "12.0.5", ngImport: i0__namespace, type: ValidateModule, deps: [], target: i0__namespace.ɵɵFactoryTarget.NgModule });
    ValidateModule.ɵmod = i0__namespace.ɵɵngDeclareNgModule({ minVersion: "12.0.0", version: "12.0.5", ngImport: i0__namespace, type: ValidateModule, declarations: [FormControlNameValidateDirective,
            FormControlValidateDirective,
            NgFormValidateDirective,
            NgModelValidateDirective], imports: [ValidatorsModule], exports: [FormControlNameValidateDirective,
            FormControlValidateDirective,
            NgFormValidateDirective,
            NgModelValidateDirective,
            ValidatorsModule] });
    ValidateModule.ɵinj = i0__namespace.ɵɵngDeclareInjector({ minVersion: "12.0.0", version: "12.0.5", ngImport: i0__namespace, type: ValidateModule, imports: [[
                ValidatorsModule
            ], ValidatorsModule] });
    i0__namespace.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "12.0.5", ngImport: i0__namespace, type: ValidateModule, decorators: [{
                type: i0.NgModule,
                args: [{
                        declarations: [
                            FormControlNameValidateDirective,
                            FormControlValidateDirective,
                            NgFormValidateDirective,
                            NgModelValidateDirective
                        ],
                        imports: [
                            ValidatorsModule
                        ],
                        exports: [
                            FormControlNameValidateDirective,
                            FormControlValidateDirective,
                            NgFormValidateDirective,
                            NgModelValidateDirective,
                            ValidatorsModule
                        ]
                    }]
            }] });

    /*
     * Angular validation plugin for  Bootstrap 4
     *  Copyright (c) 2019-2021 Rodziu <mateusz.rohde@gmail.com>
     *  License: MIT
     */

    /**
     * Generated bundle index. Do not edit.
     */

    exports.AbstractValidateElementDirective = AbstractValidateElementDirective;
    exports.EqualValidatorDirective = EqualValidatorDirective;
    exports.FormControlNameValidateDirective = FormControlNameValidateDirective;
    exports.FormControlValidateDirective = FormControlValidateDirective;
    exports.HostValidatorDirective = HostValidatorDirective;
    exports.NgFormValidateDirective = NgFormValidateDirective;
    exports.NgModelValidateDirective = NgModelValidateDirective;
    exports.NumberValidatorDirective = NumberValidatorDirective;
    exports.RequiredGroupValidatorDirective = RequiredGroupValidatorDirective;
    exports.UrlValidatorDirective = UrlValidatorDirective;
    exports.VALIDATE_ELEMENT = VALIDATE_ELEMENT;
    exports.ValidateConfigService = ValidateConfigService;
    exports.ValidateModule = ValidateModule;
    exports.Validators = Validators;
    exports.ValidatorsModule = ValidatorsModule;

    Object.defineProperty(exports, '__esModule', { value: true });

})));
//# sourceMappingURL=angular-bootstrap4-validate.umd.js.map
