import { ValidationErrors, ValidatorFn, Validators as ng2Validators } from '@angular/forms';
import { IValidateAbstractControl } from '../abstract-validate-element.directive';
export declare abstract class Validators extends ng2Validators {
    static number(control: IValidateAbstractControl): ValidationErrors | null;
    static url(mode?: 'single' | 'multiple'): ValidatorFn;
    static host(mode?: 'single' | 'multiple'): ValidatorFn;
    static equal(...controlNames: string[]): ValidatorFn;
    static requiredGroup(mode?: 'or' | 'and', value?: unknown, ...controlNames: string[]): ValidatorFn;
}
