import { ElementRef, KeyValueDiffers } from '@angular/core';
import { FormControlName } from '@angular/forms';
import { AbstractValidateElementDirective } from '../abstract-validate-element.directive';
import { ValidateConfigService } from '../validate-config.service';
import { NgFormValidateDirective } from '../template-forms/ng-form-validate.directive';
import * as i0 from "@angular/core";
export declare class FormControlNameValidateDirective extends AbstractValidateElementDirective {
    protected elementRef: ElementRef<HTMLElement | HTMLInputElement>;
    protected config: ValidateConfigService;
    protected keyValueDiffers: KeyValueDiffers;
    protected ngControl: FormControlName;
    protected ngFormValidate: NgFormValidateDirective;
    protected document: Document;
    errorMessage?: Record<string, string>;
    constructor(elementRef: ElementRef<HTMLElement | HTMLInputElement>, config: ValidateConfigService, keyValueDiffers: KeyValueDiffers, ngControl: FormControlName, ngFormValidate: NgFormValidateDirective, document: Document);
    static ɵfac: i0.ɵɵFactoryDeclaration<FormControlNameValidateDirective, [null, null, null, { self: true; }, { optional: true; }, null]>;
    static ɵdir: i0.ɵɵDirectiveDeclaration<FormControlNameValidateDirective, "[formControlName]", never, { "errorMessage": "errorMessage"; }, {}, never>;
}
